function MapExtension.Menu.Achievements.Init(parent)
	local i = 0
	for dk, dv in pairs(MapExtension.Data) do
		i = i + 1
	end

	MapExtension.Menu.Achievements.window = MapExtension.GUI.CreateFrame(parent, "CENTER", 12, -55 - i * 10, 250, 130 + i * 20, 100, MapExtension.AE.UI.Window)
	MapExtension.Menu.Achievements.window:SetVisible(false)

	MapExtension.GUI.CreateSimpleTexture(MapExtension.Menu.Achievements.window, 0, 0, 250, 12, 0, "img/tooltip250-top.png", "TOPLEFT")
	MapExtension.GUI.CreateSimpleTexture(MapExtension.Menu.Achievements.window, 0, 0, 250, 26, 0, "img/tooltip250-bottom.png", "BOTTOMLEFT")
	MapExtension.Menu.Achievements.background = MapExtension.GUI.CreateSimpleTexture(MapExtension.Menu.Achievements.window, 0, 12, 250, 92 + i * 20, 0, "img/tooltip250-middle.png", "TOPLEFT")
	MapExtension.GUI.CreateSimpleTexture(MapExtension.Menu.Achievements.background, 5, 30, 250, 5, 0, "img/tooltip-separator.png", "TOPLEFT")

	MapExtension.GUI.CreateText(MapExtension.Menu.Achievements.background, "TOPLEFT", 20, 5, MapExtension.Language.Achievements[MapExtension.AE.Language])
	MapExtension.GUI.CreateCheckbox(MapExtension.Menu.Achievements.background, "TOPLEFT", 13, 40, 100, MapExtension.Language.ShowPoints[MapExtension.AE.Language], MapExtension.AE.FilterMarks, "show", MapExtensionUISettings.achievements.show)
	MapExtension.GUI.CreateCheckbox(MapExtension.Menu.Achievements.background, "TOPLEFT", 13, 60, 100, MapExtension.Language.FilterCompleted[MapExtension.AE.Language], MapExtension.AE.FilterMarks, "filter", MapExtensionUISettings.achievements.filter)
	MapExtension.Menu.Achievements.fields = {}

	MapExtension.Menu.Achievements.Rare = {}
	for k, v in ipairs(MapExtension.Data.Rare.Data) do
		MapExtension.Menu.Achievements.Rare[(v.displayname or v.name)[MapExtension.AE.Language] or v.name[MapExtension.AE.Language]] = true
	end

	i = 0
	for dk, dv in pairs(MapExtension.Data) do
		MapExtension.GUI.CreateCheckbox(MapExtension.Menu.Achievements.background, "TOPLEFT", 13, 90 + i * 20, 100, dv.Category[MapExtension.AE.Language], MapExtension.AE.FilterMarks, dk, MapExtensionUISettings.achievements[dk])
		MapExtension.Menu.Achievements.fields[dk] = MapExtension.GUI.CreateText(MapExtension.Menu.Achievements.background, "TOPRIGHT", -20, 90 + i * 20)
		i = i + 1

		for k, v in ipairs(MapExtension.Data[dk].Data) do
			for ik, iv in ipairs(v.position) do
				MapExtension.AE.UI.MapTexture[iv.map]:AddMark(dk .. k, dk, { x = iv.x, y = iv.y }, { caption = (v.displayname or v.name)[MapExtension.AE.Language] or v.name[MapExtension.AE.Language], type = dv.Name[MapExtension.AE.Language], descrl = (iv.descrl or {})[MapExtension.AE.Language] or iv.descrl, descrr = iv.descrr })
			end
		end
	end

	MapExtension.Menu.Achievements.Load()
end

function MapExtension.Menu.Achievements.ToggleWindow(flag)
	if flag == nil then flag = not MapExtension.Menu.Achievements.window:GetVisible() end
	MapExtension.Menu.Achievements.window:SetVisible(flag)
	for dk, dv in pairs(MapExtension.Data) do
		MapExtension.Menu.Achievements.fields[dk]:SetText(MapExtension.Achievement[dk].Complete .. " / " .. MapExtension.Achievement[dk].Count)
	end
end

function MapExtension.Menu.Achievements.UnitAdd(handle, units)
	local list = Inspect.Unit.Detail(units)
	local player = Inspect.Unit.Detail("player")
	for k, v in pairs(list) do
		if v ~= false and v.name ~= nil and v.coordX ~= nil and v.coordZ ~= nil and MapExtension.Menu.Achievements.Rare[v.name] ~= nil then
			MapExtension.Messenger.Send(MapExtension.Messenger.MessageRare, { id = k, name = v.name, player = player.name, x = math.floor(v.coordX), y = math.floor(v.coordZ), zone = player.locationName .. " - " .. Inspect.Zone.Detail(player.zone).name, shard = Inspect.Shard().name })
		end
	end
end

function MapExtension.Menu.Achievements.Load()
	for k, v in pairs(MapExtension.Data) do
		MapExtension.Achievement[k] = { List = {}, Complete = 0, Count = 0, Data = 0 }

		for ak, av in ipairs(v.Achievement) do
			local achievement = Inspect.Achievement.Detail(av)
			for rk, rv in pairs(achievement.requirement) do
				local name = string.trim(rv.name)
				MapExtension.Achievement[k].List[name] = ifnull(rv.complete, false)
				MapExtension.Achievement[k].Complete = MapExtension.Achievement[k].Complete + iif(rv.complete, 1, 0)
				MapExtension.Achievement[k].Count = MapExtension.Achievement[k].Count + 1
			end
		end
	end
	MapExtension.AE.ApplyFilterMarks()
end
